Package org.zkoss.stateless.sul

## Interface IGoldenLayout

- All Superinterfaces:
    `IAnyGroup<IGoldenLayout>`, `IChildable<IGoldenLayout,​IGoldenPanel<IAnyGroup>>`, `IComponent<IGoldenLayout>`, `IHtmlBasedComponent<IGoldenLayout>`, `IXulElement<IGoldenLayout>`

      public interface IGoldenLayout
      extends IXulElement<IGoldenLayout>, IChildable<IGoldenLayout,​IGoldenPanel<IAnyGroup>>, IAnyGroup<IGoldenLayout>

  Immutable `GoldenLayout` component

  GoldenLayout is a layout container which layouts panels as docker type and is used to represent GoldenLayout. GoldenLayout is the parent component, and its children component can only be GoldenPanel.

  A GoldenLayout could be nested to another GoldenLayout (actually, almost all kinds of components) to form a complicated layout.

  Author:
    katherine
  See Also:
    `GoldenLayout`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `IGoldenLayout.Builder` | Builds instances of type `IGoldenLayout`.
    `static class` | `IGoldenLayout.Orient` | Specifies the orient of `IGoldenLayout` component
    `static class` | `IGoldenLayout.Updater` | Builds an updater of type `IGoldenLayout` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static IGoldenLayout` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `getAreas()` | Return the area of this GoldenPanel.
    `default java.lang.String` | `getOrient()` | Returns the layout dividing orientation.
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `static IGoldenLayout` | `of​(java.lang.Iterable<? extends IGoldenPanel<IAnyGroup>> children)` | Returns the instance with the given `IGoldenPanel` children.
    `static IGoldenLayout` | `of​(IGoldenPanel<IAnyGroup>... children)` | Returns the instance with the given `IGoldenPanel` children.
    `static IGoldenLayout` | `ofFlex​(java.lang.String hflex, java.lang.String vflex)` | Returns the instance with the given vflex and hflex
    `static IGoldenLayout` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `static IGoldenLayout` | `ofSize​(java.lang.String width, java.lang.String height)` | Returns the instance with the given width and height
    `IGoldenLayout` | `withAreas​(java.lang.String areas)` | Returns a copy of `this` immutable component with the specified `areas`.
    `IGoldenLayout` | `withOrient​(java.lang.String orient)` | Returns a copy of `this` immutable component with the specified `orient`.
    `default IGoldenLayout` | `withOrient​(IGoldenLayout.Orient orient)` | Returns a copy of `this` immutable component with the specified `orient`.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IChildable

      `getChildren, withChildren, withChildren`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final IGoldenLayout DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zkmax.goldenlayout.GoldenLayout"`

      Specified by:
        `getWidgetClass` in interface `IComponent<IGoldenLayout>`

    - #### getAreas

          @Nullable
          java.lang.String getAreas()

      Return the area of this GoldenPanel.

      Default: `null`

    - #### withAreas

          IGoldenLayout withAreas​(@Nullable
                                  java.lang.String areas)

      Returns a copy of `this` immutable component with the specified `areas`.

      Sets a matrix-like areas template, supports only on initial rendering. Notice that areas is only supported for the initial rendering. (i.e. it won't work with `IGoldenLayout.Updater`)

      Parameters:
        `areas` - The template of the goldenlayout.

        Default: `null`.

      Returns:
        A modified copy of the `this` object

    - #### getOrient

          default java.lang.String getOrient()

      Returns the layout dividing orientation.

      Default: `"vertical"`

    - #### withOrient

          IGoldenLayout withOrient​(java.lang.String orient)

      Returns a copy of `this` immutable component with the specified `orient`.

      Sets the orient of component

      Parameters:
        `orient` - Either `"horizontal"` or `"vertical"`

        Default: `"vertical"`.

      Returns:
        A modified copy of the `this` object

    - #### withOrient

          default IGoldenLayout withOrient​(IGoldenLayout.Orient orient)

      Returns a copy of `this` immutable component with the specified `orient`.

      Sets the orient of component

      Parameters:
        `orient` - The `orient`

        Default: `"vertical"`.

      Returns:
        A modified copy of the `this` object

    - #### of

          static IGoldenLayout of​(java.lang.Iterable<? extends IGoldenPanel<IAnyGroup>> children)

      Returns the instance with the given `IGoldenPanel` children.
      Parameters:
        `children` - The children of `IGoldenPanel`

    - #### of

          static IGoldenLayout of​(IGoldenPanel<IAnyGroup>... children)

      Returns the instance with the given `IGoldenPanel` children.
      Parameters:
        `children` - The children of `IGoldenPanel`

    - #### ofSize

          static IGoldenLayout ofSize​(java.lang.String width,
                                      java.lang.String height)

      Returns the instance with the given width and height
      Parameters:
        `width` - The width of the component
        `height` - The height of the component

    - #### ofFlex

          static IGoldenLayout ofFlex​(java.lang.String hflex,
                                      java.lang.String vflex)

      Returns the instance with the given vflex and hflex
      Parameters:
        `hflex` - The horizontal flex hint
        `vflex` - The vertical flex hint

    - #### ofId

          static IGoldenLayout ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component